package com.shanghaichengdi.downloadcenterserver.faced;

import cn.hutool.http.HttpResponse;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson.JSONObject;
import com.shanghaichengdi.downloadcentercommon.util.ImageDownload;
import com.shanghaichengdi.downloadcenterserver.cache.UrlData;
import java.io.File;
import java.net.URL;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

import com.shanghaichengdi.downloadcenterserver.util.PrintLogUtils;
import lombok.Getter;
import lombok.extern.slf4j.Slf4j;

/**
 * @author gengaoliu
 */
@Slf4j
public class PicDownloadFaced extends Thread {

  private List<String> imageUrls;
  private String passTime;
  private String id;
  @Getter
  private String bayonetId;

  public PicDownloadFaced(List<String> imageUrls, String passTime, String id, String bayonetId) {
    this.imageUrls = imageUrls;
    this.passTime = passTime;
    this.id = id;
    this.bayonetId = bayonetId;
  }

  @Override
  public void run() {
    try {
      List<String> imgUrlToSave = new ArrayList<>(this.imageUrls.size());
      String time = passTime;
      SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
      Date times = formatter.parse(time);
      formatter = new SimpleDateFormat("yyyy_MM_dd_HH_mm_ss");
      SimpleDateFormat formatter1 = new SimpleDateFormat("yyyyMMdd_HHmmss");
      String dir = formatter.format(times);
      String newTime = formatter1.format(times);
      String year = dir.split("\\_")[0];
      String month = dir.split("\\_")[1];
      String day = dir.split("\\_")[2];
      String hour = dir.split("\\_")[3];
      String dirs = year + "/" + year + month + day + "/" + hour;
      int i = 0;
      String dirtory = "/data/dataShareFolder/bayonetPhoto/origin/" + bayonetId + "/";
//    String dirtory = "E:/disk/dataShareFolder/bayonetPhoto/origin/" + bayonetId + "/";
      File photoDir = new File(dirtory + dirs);
      photoDir.mkdirs();
      StringBuilder targetFilePath = new StringBuilder();
      for (String imageUrl : imageUrls) {
        boolean isSuccess = false;
        String urlToSave = dirs + "/" + "P" + i + "_" + newTime + ".jpg";
        String photoFile = dirtory + urlToSave;
        while (!isSuccess) {
          isSuccess = ImageDownload.download(imageUrl, photoFile);
        }
        imgUrlToSave.add(urlToSave);
        targetFilePath.append(photoFile).append(";");
        i++;
      }
//    log.warn("====>  当前队列值:{}", UrlData.URL_IMG_TO_SAVE);
      addQueue(id, imgUrlToSave);
//    log.warn("======>   取出并移除首位元素:{}", JSONObject.toJSONString(UrlData.URL_IMG_TO_SAVE.poll()));
      Map<String, List<String>> polled = UrlData.URL_IMG_TO_SAVE.poll();
      //这里调用一个新的接口用于接收存储videoAnalysis数据
      //组装参数
      JSONObject jsonObject = new JSONObject();
      jsonObject.put("id", id);
      jsonObject.put("photoName", targetFilePath.toString());
      //这里去调用接口异步调用即可
//    private final static String GH_CLOUD_SERVER = "http://10.83.68.108:8090/ghjgBayonetDataShareApi/analyse/receive";
      log.info("======>   id:" + id + "，bindDownloadedPicture发送请求参数:{}", jsonObject);
      HttpResponse httpResponse = HttpUtil.createPost("http://10.83.68.108:8090/ghjgBayonetDataShareApi/videoAnalysis/bindDownloadedPicture").body(jsonObject.toString()).executeAsync();
      log.info("======>   id:" + id + "，httpResponse:{}", httpResponse.body());
//    HttpUtil.createPost("http://127.0.0.1:9005/videoAnalysis/bindDownloadedPicture").body(jsonObject.toString()).executeAsync();
    }catch (Exception e){
      PrintLogUtils.printErrorLogInfo(e,"id:"+id+",imageUrl:"+imageUrls+",download picture error：");
    }
  }

  private synchronized static void addQueue(String id, List<String> imgUrlToSave) {
    Map<String, List<String>> map = new HashMap<>();
    map.put(id, imgUrlToSave);
    UrlData.URL_IMG_TO_SAVE.add(map);
  }
}
